package it.inaf.oats.ia2.tapschemamanager.api.contract;

/**
 * {@link TapSchemaEntity} that represents the table
 * {@code TAP_SCHEMA.key_columns}.
 *
 * @author Sonia Zorba {@literal <zorba at oats.inaf.it>}
 */
public interface KeyColumn extends TapSchemaEntity {

    static final String KEY_ID_KEY = "key_id";
    static final String FROM_COLUMN_KEY = "from_column";
    static final String TARGET_COLUMN_KEY = "target_column";
    static final String KEY_COLUMN_ID_KEY = "key_columnID";

    /**
     * The value in the {@code key_id} column.
     */
    String getKeyId();

    void setKeyId(String keyId);

    /**
     * The value in the {@code from_column} column.
     */
    String getFromColumn();

    /**
     * The value in the {@code target_column} column.
     */
    String getTargetColumn();

    /**
     * The value in the {@code key_columnID} column: it represents [TODO]...
     */
    Long getKeyColumnID();

    void setKeyColumnID(Long keyColumnID);
}
