package it.inaf.oats.ia2.tapschemamanager.api.contract;

/**
 * {@link TapSchemaEntity} that represents the table {@code TAP_SCHEMA.schemas}.
 *
 * @author Sonia Zorba {@literal <zorba at oats.inaf.it>}
 */
public interface Schema extends EntitiesContainer<Table>, ChildEntity<TapSchema> {

    final static String SCHEMA_NAME_KEY = "schema_name";
    final static String UTYPE_KEY = "utype";
    final static String DESCRIPTION_KEY = "description";
    final static String SCHEMA_ID = "schemaID";

    /**
     * The value in the {@code utype} column.
     */
    String getUtype();

    void setUtype(String utype);

    /**
     * The value in the {@code description} column.
     */
    String getDescription();

    void setDescription(String description);

    /**
     * The value in the {@code schemaID} column: it represents [TODO]...
     */
    Long getSchemaID();

    void setSchemaID(Long schemaID);
}
