package it.inaf.oats.ia2.tapschemamanager.api.contract;

import java.sql.SQLException;

/**
 * Represents a TAP_SCHEMA.
 * 
 * @author Sonia Zorba {@literal <zorba at oats.inaf.it>}
 */
public interface TapSchema extends EntitiesContainer<Schema> {

    public static final String TABLES_TABLE = "tables";
    public static final String SCHEMAS_TABLE = "schemas";
    public static final String COLUMNS_TABLE = "columns";
    public static final String KEYS_TABLE = "keys";
    public static final String KEY_COLUMNS_TABLE = "key_columns";

    /**
     * The name of the TAP_SCHEMA schema.
     */
    String getName();

    /**
     * The version selected for this TAP_SCHEMA.
     */
    TapSchemaVersion getVersion();

    /**
     * Save or update the TAP_SCHEMA changes into the database.
     */
    void save() throws SQLException;

    /**
     * Define if the TAP_SCHEMA schema was already written into the database.
     */
    boolean exists();
}
